import java.awt.*; 
import java.io.*; 
import javax.servlet.*; 
import javax.servlet.http.*; 

import Acme.JPM.Encoders.GifEncoder; 

public class ImageCounter extends HttpServlet { 

 	public static final String DIR = "/images/numbers"; 
	 public static final String COUNT = "9876543210"; 

	 public void doGet( 
	            HttpServletRequest req, HttpServletResponse res) 
	            throws ServletException, IOException { 
	  ServletOutputStream out = res.getOutputStream(); 
	
	  Frame frame = null; 
	  Graphics g = null; 
	
	  try { 
	   /* zistme hodnotu, ktor sa m zobrazi, 
	   mus to by samostatn reazec bez mena, 
	   alebo sa pouije hodnota COUNT */ 
	   String count = (String) req.getQueryString(); 
	   if (count == null) count = COUNT; 
	
	   //vytvorme jednorozmern pole objektov Images 
	   int countlen = count.length(); 
	   Image images[] = new Image[countlen]; 
	
	   //toto pole naplnme jednotlivmi obrzkami 
	   for (int i = 0; i < countlen; i++) { 
		  String imageSrc = getServletContext().getRealPath( 
	                       DIR + "/" + count.charAt(i) + ".gif"); 
		  images[i] = Toolkit.getDefaultToolkit().getImage(imageSrc); 
	   } 

	   //vytvorme frame 
	   frame = new Frame(); 
	   frame.addNotify(); 
	
	   //natiahneme obrzky do pamte 
	   MediaTracker mt = new MediaTracker(frame); 
	   for (int i = 0; i < countlen; i++) { 
	   mt.addImage(images[i], i); 
	   } 
	   try { 
	    mt.waitForAll(); 
	   } 
	   catch (InterruptedException e) { 
		    getServletContext().log("Chyba pri natan obrzka", e); 
		    throw new ServletException(e.getMessage()); 
	   } 

	   /* kontrola na vzniknut chyby, ktor 
	   sa mohli objavi pri natan obrzkov */ 
	   if (mt.isErrorAny()) { 
	    /* ak mme problm, treba uri, 
	    o ktor obrzok(ky) sa jedn */ 
	    StringBuffer errorChars = new StringBuffer(); 
	    for (int i = 0; i < countlen; i++) { 
	     if (mt.isErrorID(i)) { 
	      errorChars.append(count.charAt(i)); 
	     } 
	    } 
	    throw new ServletException("Problm vznikol v: " + 
	                                      errorChars.toString()); 
	   } 
	
	   //zistme celkov vekos obrzkov 
	   int width = 0; 
	   int height = 0; 
	   for (int i = 0; i < countlen; i++) { 
	    width += images[i].getWidth(frame); 
	    height = Math.max(height, images[i].getHeight(frame)); 
	   } 
	
	   /* vytvorme przdny Image s rozmermi 
	   odpovedajcimi celkovej vekosti obrzkov, 
	   a zskame jeho grafick kontext */ 
	   Image image = frame.createImage(width, height); 
	   g = image.getGraphics(); 
	
	   //vlome jednotliv obrzky 
	   int xindex = 0; 
	   for (int i = 0; i < countlen; i++) { 
	    g.drawImage(images[i], xindex, 0, frame); 
	    xindex += images[i].getWidth(frame); 
	   } 
	
	   //vsledok zakdujeme a poleme 
	   res.setContentType("image/gif"); 
	   GifEncoder encoder = new GifEncoder(image, out); 
	   encoder.encode(); 
	  } 
	
	  //uvonme zdroje 
	  finally { 
	   if (g != null) g.dispose(); 
	   if (frame != null) frame.removeNotify(); 
	  } 
  } 
}