import java.awt.*; 
import java.io.*; 
import javax.servlet.*; 
import javax.servlet.http.*; 

import Acme.JPM.Encoders.GifEncoder; 

public class TopSecretImage extends HttpServlet { 

	 Frame frame = null; 
	 Graphics g = null; 

	 public void init(ServletConfig config) 
	                throws ServletException { 
	  super.init(config); 
	  //vytvorme viacnsobne pouiten frame 
	  frame = new Frame(); 
	  frame.addNotify(); 
	 } 
	
	 public void doGet( 
	          HttpServletRequest req, HttpServletResponse res) 
	          throws ServletException, IOException { 
	  ServletOutputStream out = res.getOutputStream(); 
	
	  try { 
	   //zskeme info o umiestnen obrzka 
	   String source = req.getPathTranslated(); 
	   if (source == null) { 
	    throw new ServletException("Chyba v hadan obrzka"); 
	   } 
	
	   //natiahneme obrzok do pamte 
	   MediaTracker mt = new MediaTracker(frame); 
	  Image image = Toolkit.getDefaultToolkit().getImage(source); 
	   mt.addImage(image, 0); 
	   try { 
	    //spustme natanie 
	    mt.waitForAll(); 
	   } 
	   catch (InterruptedException e) { 
	    getServletContext().log("Chyba pri natan obrzka, e"); 
	    throw new ServletException(e.getMessage()); 
	   } 
	
	   /* vytvorme nov grafick kontext s 
	   rovnakmi rozmermi ak m obrzok */
	   int w = image.getWidth(frame); 
	   int h = image.getHeight(frame); 
	   Image offscreen = frame.createImage(w, h); 
	   g = offscreen.getGraphics(); 
	
	   //vlome obrzok do graf. kontextu 
	   g.drawImage(image, 0, 0, frame); 
	
	   //do kontextu zapeme "Top Secret!" 
	   g.setColor(Color.RED); 
	   g.setFont(new Font("Monospaced", Font.BOLD, 30)); 
	   g.drawString("Top Secret!", 60, 80); 
	
	   //zakdujeme a poleme klientovi 
	   res.setContentType("image/gif"); 
	   GifEncoder encoder = new GifEncoder(offscreen, out); 
	   encoder.encode(); 
	  } 
	  finally { 
	   //uvonme zdroje 
	   if (g != null) g.dispose(); 
	  } 
   } 
	
 //uvonme zdroje 
 public void destroy() { 
  if (frame != null) frame.removeNotify(); 
 } 
}